#!/nfs/public/bin/sybperl
#
# Program:  hdassign.pl       Description:  Assigns a helpdesk ticket to a 
#                                           support person.
#
# This is part of the Helpdesk Management System written by Mark Mellman.
#
# Date last revision: 07/07/96   Version: 2.00

require "helpdesk.inc";

&helpdesk_login;
$str="select * from Owner";
&dbcmd($dbproc, $str);
&dbresults($dbproc);
&dbsqlexec ($dbproc);
$cnt=1;
if(&dbresults($dbproc)==&SUCCEED) {
  while(@data=&dbnextrow($dbproc)) {
    $supid[$cnt]=$data[0];
    $supnam[$cnt]=$data[1];
    $supema[$cnt]=$data[2];
    $cnt=$cnt+1;
  }
}
$cnt=$cnt-1;

#####################################################
# pull apart query string
#####################################################

$buffer=$ENV{'QUERY_STRING'};
#if( $buffer eq "" ) { &do_ask(); }
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value=~ tr/+/ /;
  $value=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
}
$ticknum=$FORM{"ticknum"};
$owner=$FORM{"owner"};

##############################################################
# If ticket number is entered, get the info and display it
##############################################################

if ($ticknum > 0) {
  &helpdesk_login;
  $str="select * from OTicket where ticketId = $ticknum";
  &dbcmd($dbproc, $str);
  &dbresults($dbproc);
  &dbsqlexec ($dbproc);
  if(&dbresults($dbproc)==&SUCCEED) {
    @data=&dbnextrow($dbproc);
    &do_html(@data);
  }
  print "</html>\n";
  exit;
}

##############################################################
# If "unassigned" is selected, show all unassigned tickets
##############################################################

if( $owner == 0 ) {
  $hld=0;
  $hld1="Unassigned";
  &do_ask;
  $dbproc = &dblogin("$opt_u", $pw, $opt_s);
  &dbuse($dbproc, $opt_d);
  &dbuse ($opt_d);
  $str="select * from OTicket where status = \"U\"";
  &dbcmd($dbproc, $str);
  &dbresults($dbproc);
  &dbsqlexec ($dbproc);
  if(&dbresults($dbproc)==&SUCCEED) {
    while(@data=&dbnextrow($dbproc)) {
      &do_point(@data);
    }
  }
  print "</body>\n";
  print "</html>\n";
  exit;
}

##############################################################
# Get all tickets for $owner and display
##############################################################

if( $owner != 0  ) {
  $hld=$owner;
  $hld1=$supnam[$hld];
  &do_ask;
  &helpdesk_login;
  $str="select * from OTicket where ownerId = $owner and status = \"A\"";
  &dbcmd($dbproc, $str);
  &dbresults($dbproc);
  &dbsqlexec ($dbproc);
  if(&dbresults($dbproc)==&SUCCEED) {
    while(@data=&dbnextrow($dbproc)) {
      &do_point(@data);
    }
  }
  print "</html>\n";
  exit;
}

#########################################################
# Do the isql query
#########################################################

sub do_isql
{
   &dbcmd($dbproc, $str);
   if (&dbsqlexec ($dbproc) !=&SUCCEED)
   {
      print "Error executing command\n";
   }
   &dbresults($dbproc);
}

#######################################################
# Setup html code and display ticket detail form.
#######################################################

sub do_html {
@tmp=@_;
print "Content-type: text/html\n\n";
printf "
  <head>
  <title>Problem Ticket Maintenance</title>
  </head>
  <body bgcolor=\"#FFFFFF\" text=\"#000000\" link=\"#CC0000\" alink=\"#FF3300\" vlink=\"#330099\">
  <center><h1>Problem Ticket Number %d</h1></center>
  <table border>
  <tr>
  <td><b>Submitted by:</b>  %s %s</td> 
  <td><b>Date Submitted:</b> %s</td> 
  <td><b>Date Needed:</b> %s</td> 
  </tr>
  <tr>
  <td><b>Status:</b>  %s</td>  
  <td><b>Department:</b> %s</td> 
  <td><b>Problem Type:</b> %s</td>
  </tr> 
  <tr>
  <td><b>Priority:</b>  %s</td>
  </tr>
  </table>
   ",$tmp[0],$tmp[8],$tmp[9],$tmp[1],$tmp[2],$tmp[3],$tmp[4],$tmp[5],$tmp[10];
  $tmp[6]=~ s/\n/\<br\>/g;
printf "
  <p>
  <p>
  <b>Request Description:</b>
  <table>
  <tr>
  <td>%s %s</td>
  </tr>
  </table>
  <hr>
  ",$tmp[6], $tmp[7];
printf "
  <form METHOD=\"post\" ACTION = \"$CGIDIR/hdassign1.pl\">
  <table>
  <tr>
  <td>
  <input type=\"hidden\" name=\"ticket\" value=\"%d\">
  Assigned To: <select name=\"assignedTo\">
  <option value=\"0\">Same\n", $tmp[0];
  for($i=1; $i<$cnt+1; ++$i) {
    printf "<option value=\"%s\">%s\n",$supid[$i],$supnam[$i];
  }
printf "
  </select>
  </td>
  <td>
  Time Spent: <input name=\"timeSpent\" size=5>
  </td>
  <td>
  Status: <select name=\"status\" >
  <option value=\"$tmp[3]\">Unchanged
  <option value=\"C\">Closed
  <option value=\"U\">Unassigned
  <option value=\"A\">Assigned
  </select>
  </td>
  </table>
  Keywords:  <input name=\"keyWords\" size=60>
  <p>
  <p>
  Resolution:
  <textarea name=\"resolution\" rows=15 cols=65>
  </textarea>
  <hr>
  <center>
  <td><input type=\"submit\" value = \"Submit\"></td>
  </center>
  </form>
";
&detail_disp;
&prob_key;
print "
  </body>
  </html>";
}

#############################################################
# Display opening form and ask for input
#############################################################

sub do_ask {
print "Content-type: text/html\n\n";
print "
<html>
<head>
<title>Systems Help Desk Response Form</title>
</head>
<body bgcolor=\"#FFFFFF\" text=\"#000000\" link=\"#CC0000\" alink=\"#FF3300\" vlink=\"#330099\">
<center>
<h1>Systems Help Desk Response Form</h1>
<font size=2>Comments, questions, suggestions, problems should be directed
to <a href=\"mailto:$WEBMSTR\">$WEBMSTR</a> 
<hr>
</center>
<form METHOD=\"put\" ACTION = \"$CGIDIR/hdassign.pl\">

Enter Ticket Number: <input name=\"ticknum\" size=10>
<td><input type=\"submit\" value = \"Submit\"></td>
<br>
Enter Ticket Owner: <select name=\"owner\">
<option value=\"$hld\">$hld1\n";
  $supid[$hld]="0";
  $supnam[$hld]="Unassigned";
  for($i=1; $i<$cnt+1; ++$i) {
    printf "<option value=\"%s\">%s\n",$supid[$i],$supnam[$i];
  }
printf "</select>
<td><input type=\"submit\" value = \"Submit\"></td>
<pr>
";
}

################################################################
# Display detail lines (list each ticket) for selection form.
################################################################

sub do_point {
@tmp=@_;
printf "<br><a href=\"hdassign.pl?ticknum=%d\">%5.5d</a>
<br>
Request:
%s
<br>\n", $tmp[0], $tmp[0], $tmp[6];
}

#######################################################
# Display past ticket detail
#######################################################

sub detail_disp {

  &do_htmlhead;
  $str="select * from CTicket where ticketId = $ticknum";
  &do_isql;
  while(@data=&dbnextrow($dbproc)) {
    &do_html1(@data);
  }
 print "</table>\n";
}

#######################################################
# Display Problem Type key at bottom of form
#######################################################

sub prob_key {

  $str="select * from ProblemTypes";
  &dbcmd($dbproc, $str);
  &dbresults($dbproc);
  &dbsqlexec ($dbproc);
  $cnt=0;
  if(&dbresults($dbproc)==&SUCCEED) {
    while(@data=&dbnextrow($dbproc)) {
      $x[$cnt]=$data[0];
      $x1[$cnt]=$data[1];
      $cnt=$cnt+1;
    }
  }
  print "<h2>Keys:</h2><hr>
  Problem Types:<p><table border><tr>";
  for ($i=0; $i<3; ++$i) {
    print "<td>Type</td><td>Description</td>";
  }
  print "</tr>";
  $cnt=$cnt-1;
  for ($i=0; $i<$cnt+1; $i=$i+3) {
    print "<tr>";
    for ($xy=0; $xy<3; ++$xy) {
      if( $x[$i+$xy] > 0) { printf "<td>%2.2d</td><td>%-18.18s</td>",$x[$i+$xy], $x1[$i+$xy]}; 
    }
    print "</tr>";
  }
  print "</table>";
}

#######################################################
#  Display detail record heading for past events
#######################################################

sub do_htmlhead {

printf "
  <table border>
  <th>Date</th><th>Done By</th><th>Description</th><th>Status</th>"
}

#######################################################
#  Display detail record information (CTicket)
#######################################################

sub do_html1 {
@tmp=@_;
printf "
  <tr>
  <td>%s</td><td>%s</td><td>%s %s</td><td>%s</td>
  </tr>
  ", $tmp[3], $tmp[4], $tmp[2], $tmp[7], $tmp[6];
}

