#!/nfs/public/bin/sybperl
#
# Program:  hdowned.pl      Description:  Display table with each support
#                                         person, number of tickets open, 
#                                         and average days open
#
# This is part of the Helpdesk Management System written by Mark Mellman.
#
# Date last revision: 08/16/96   Version: 2.00

require "helpdesk.inc" ;

&helpdesk_login;

$tottick=0;
&startup;
$str="
select count(ticketId), assigned, avg(datediff(day, submitDate, getdate()))
from OTicket where status = \"A\" or status = \"U\" group by assigned";
&dbcmd($dbproc, $str);
&dbresults($dbproc);
&dbsqlexec ($dbproc);
if(&dbresults($dbproc)==&SUCCEED) {
  while(@data=&dbnextrow($dbproc)) {
    &do_point(@data);
  }
}
printf "<tr><td>%5.5d</td><td>Total Tickets</td><td></td></tr>", $tottick;
print "</table>\n";
print "</center>\n";
print "</html>\n";
exit;

#########################################################
#  Do the isql query
#########################################################

sub do_isql
{
   &dbcmd($dbproc, $str);
   if (&dbsqlexec ($dbproc) !=&SUCCEED)
   {
      print "Error executing command\n";
   }
   &dbresults($dbproc);
}

#######################################################
#  Display detail line
#######################################################

sub do_point {
  @tmp=@_;
  printf "<tr><td>%5.5d</td><td>%s</td><td>%5.5d</td></tr>\n", $tmp[0], $tmp[1], $tmp[2];
  $tottick=$tottick+$tmp[0];
}

#######################################################
#  Display header information for table
#######################################################

sub startup {
  print "Content-type: text/html\n\n";
  print "<body  bgcolor=\"#FFFFFF\" text=\"#000000\" link=\"#CC0000\" alink=\"#FF3300\" vlink=\"#330099\">\n";
  print "<center><font size=+2>Number of Tickets Assigned to Each Person</font></center><br>\n";
  print "<hr><br>\n";
  print "<center>\n";
  print "<table border>\n";
  print "<tr><td>Number of Tickets</td><td>Assigned to</td><td>Avg Days Open</td></tr>\n";
}
