#!/nfs/public/bin/sybperl
#
# Program:  hdword.pl      Description:  Search for a word in the master
#                                        records and all details and display
#                                        a page with href'd ticket numbers
#                                        to see detail.
#
# This is part of the Helpdesk Management System written by Mark Mellman.
#
# Date last revision: 08/16/96   Version: 2.00

require "helpdesk.inc";

##################################################
# Pull apart query string from hdword.html
##################################################

$buffer=$ENV{'QUERY_STRING'};
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value=~ tr/+/ /;
  $value=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
}
$word=$FORM{"word"};
$nam =~ tr/a-z/A-Z/;

##################################################
# Display error message if no string is entered
##################################################

if( $word eq "" || $word eq "\%") {
  print "Content-type: text/html\n\n";
  print "<body>\n";
  print "<center><h2>You MUST enter a word to search for!</h2></center>\n";
  print "<br>";
  print "<br>";
  print "<br>";
  print "<br>";
  print "<br>";
  print "<br>";
  print "<br>";
  print "<center><a href=\"../../hdword.html\">Try Again.</a></center>\n";
  print "</html>\n";
  exit;
}

#########################################################################
#  Do a join of the master record and the detail record and search for
#  the word.
#########################################################################

&startup;
&helpdesk_login;
$str="
select distinct o.ticketId, o.requestDescription, o.requestDescription2,
  c.resolution, c.resolution1 from OTicket o, CTicket c
  where (o.requestDescription like \"%$word%\" or
       o.requestDescription2 like \"%$word%\" or
       c.resolution like \"%$word%\" or
       c.resolution1 like \"%$word%\") and
  c.ticketId = o.ticketId";
&dbcmd($dbproc, $str);
&dbresults($dbproc);
&dbsqlexec ($dbproc);
if(&dbresults($dbproc)==&SUCCEED) {
  while(@data=&dbnextrow($dbproc)) {
    &do_point(@data);
  }
}
print "</html>\n";
exit;

#########################################################
#  Do the isql query
#########################################################

sub do_isql
{
   &dbcmd($dbproc, $str);
   if (&dbsqlexec ($dbproc) !=&SUCCEED)
   {
      print "Error executing command\n";
   }
   &dbresults($dbproc);
}

##############################################################
#  Display ticket containing with the ticket number href'd
##############################################################

sub do_point {
@tmp=@_;
printf "Ticket:  <a href=\"hdstatus.pl?ticknum=%d\">%5.5d</a>
<br>
Request:<br>
%s<br>
%s<br>
<br>
Resolution:<br>
%s<br>
%s<br>
<br>
<br><br>\n", $tmp[0], $tmp[0], $tmp[1], $tmp[2], $tmp[3], $tmp[4];
}

##############################################################
#  Display html header 
##############################################################

sub startup {
  print "Content-type: text/html\n\n";
  print "<body>\n";
}
